/************************************************************************/
/*                                                                      */
/*                      RC5 Remote Receiver                             */
/*                                                                      */
/*              Author: Peter Dannegger                                 */
/*                      danni@specs.de                                  */
/************************************************************************/
//#include <util/delay.h>
//#include <io.h>
//#include <interrupt.h>
//#include <signal.h>
//#include <stdlib.h>

#include "RC5.h"

#define RC5TIME 	1.778e-3		// 1.778msec
#define PULSE_MIN	(uchar)(XTAL / 512 * RC5TIME * 0.4 + 0.5)
#define PULSE_1_2	(uchar)(XTAL / 512 * RC5TIME * 0.8 + 0.5)
#define PULSE_MAX	(uchar)(XTAL / 512 * RC5TIME * 1.2 + 0.5)



uchar	rc5_bit;					// bit value
uchar	rc5_time;					// count bit time
uint	rc5_tmp;					// shift bits in
volatile uint	rc5_data;			// store result



ISR (TIM0_OVF_vect)	//Timer/Counter0 Overflow an Tiny44 angepasst. Wenn z.B. vom AT90S2313 der Name drin steht, gibt es keine Fehlermeldung, aber das Programm hngt sich auf.
{

//  static char enc_last = 0x01;		//fr Drehencoder
//  char i = 0;						//fr Drehencoder


	uint tmp = rc5_tmp;				// for faster access

	TCNT0 = -2;					// 2 * 256 = 512 cycle			//die PWM geht nur, wenn diese Zeile auskommentiert ist, RC5 dann nicht mehr
  
//  		PORTB ^= (1 << PB1);    // LED toggeln PB1
//				 _delay_ms( 25 );

  if( ++rc5_time > PULSE_MAX ){			// count pulse time
    if( !(tmp & 0x4000) && tmp & 0x2000 )	// only if 14 bits received
      rc5_data = tmp;
    tmp = 0;
  }

  if( (rc5_bit ^ xRC5_IN) & 1<<xRC5 ){		// change detect
    rc5_bit = ~rc5_bit;				// 0x00 -> 0xFF -> 0x00

    if( rc5_time < PULSE_MIN )			// to short
      tmp = 0;

    if( !tmp || rc5_time > PULSE_1_2 ){		// start or long pulse time
      if( !(tmp & 0x4000) )			// not to many bits
        tmp <<= 1;				// shift
      if( !(rc5_bit & 1<<xRC5) )		// inverted bit
        tmp |= 1;				// insert new bit
      rc5_time = 0;				// count next pulse time
    }
  }

  rc5_tmp = tmp;

}	//Ende ISR